package org.example.controllers;

import org.example.objects.SearchDTO;
import org.example.services.PostService;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/search")
public class SearchController {
    private final PostService postService;

    public SearchController(PostService postService) {
        this.postService = postService;
    }


    @GetMapping("/search_result")
    public ResponseEntity<List<SearchDTO>> searchRelatedTopics(@RequestParam String key){
        List<SearchDTO> searchResult  =  postService.searchRelatedTopics(key);
        return new ResponseEntity<>(searchResult, HttpStatus.OK);
    }
}
